float2 R;
float M[8]={1,1,1,1,1,1,1,1};
#define PW M[6]
#define fMIN M[0]
#define fMAX M[1]
#define dmin M[2]
#define dmax M[3]
#define gamm M[4]
#define fade M[5]
texture tex0,tex1;
sampler s0=sampler_state{Texture=(tex0);MipFilter=LINEAR;MinFilter=LINEAR;MagFilter=LINEAR;};
sampler s1=sampler_state{Texture=(tex1);MipFilter=LINEAR;MinFilter=LINEAR;MagFilter=LINEAR;};
float4 p0(float2 vp:vpos):COLOR0{float2 x=(vp+.5)/R;
       float4 c=tex2Dlod(s0,float4(x,0,2));
       float grey=max(c.r,max(c.g,c.b));
       float4 pre=tex2D(s1,x);
       float ff=pow(saturate(fade),.5);
       c.z=1./lerp(abs(grey),1./pre.z,ff);
       c.x=pow(lerp(abs(grey),pow(pre.x,1./PW),ff),PW);
       c.y=lerp(abs(grey),pre,ff).y;
       return c;
}
float4 p1(float2 vp:vpos):COLOR0{float2 x=(vp+.5)/R;
       float4 c=tex2Dlod(s1,float4(x,0,99));
       float cmax=pow(c.x,1./PW);
       float cmin=pow(1./(c.z),1./(1.0));
       float cavg=c.y;
       cmax=lerp(dmax,cmax,fMAX);
       cmin=lerp(dmin,cmin,fMIN);
       cavg=(cavg-cmin)/max(cmax,.00000001);
       c.rgb=max(0,tex2D(s0,x).rgb-cmin)/max(cmax,.0001);
       c.rgb=normalize(c.rgb)*pow(length(c.rgb),pow(.5/cavg,gamm));
       c.w=tex2D(s0,x).w;
       return c;
}
float4 p2(float2 vp:vpos):COLOR0{float2 x=(vp+.5)/R;
       float4 c=tex2Dlod(s1,float4(.5,.5,0,99));
       return c;
}
void vs2d(inout float4 vp:POSITION0){vp.xy*=2;}
technique t{

          pass P0{vertexshader=compile vs_3_0 vs2d();PixelShader=compile ps_3_0 p0();}
          pass P1{vertexshader=compile vs_3_0 vs2d();PixelShader=compile ps_3_0 p1();}
          pass P1{vertexshader=compile vs_3_0 vs2d();PixelShader=compile ps_3_0 p2();}
}
